#ifndef NOSUCHDEBUG_H
#define NOSUCHDEBUG_H

#include <string>

extern int NosuchDebugLevel;
extern bool NosuchDebugToConsole;
extern bool NosuchDebugToLog;
extern bool NosuchDebugAutoFlush;
extern std::string NosuchDebugLogFile;
extern std::string NosuchDebugPrefix;

// If you want a NosuchDebug() message to go to error output as well
// as the debug log, use this as the level
#define ERROR_OUTPUT -1

void NosuchDebugDumpLog();
void NosuchDebug(std::string);
void NosuchDebug(int level, std::string);
void NosuchDebug(char const *fmt, ... );
void NosuchDebug(int level, char const *fmt, ... );
void NosuchErrorOutput(const char *fmt, ...);

#define NosuchAssert(expr) if(!(expr)){ throw NosuchException("NosuchAssert (%s) failed at %s:%d",#expr,__FILE__,__LINE__);}

#endif
